<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Sound Manager: R:/SoundManagerBinding/libsoundmanager/libsoundmanager.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Sound Manager
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('libsoundmanager_8cpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">libsoundmanager.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="libsoundmanager_8cpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2017 TOYOTA MOTOR CORPORATION</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * you may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * You may obtain a copy of the License at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *      http://www.apache.org/licenses/LICENSE-2.0</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Unless required by applicable law or agreed to in writing, software</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * See the License for the specific language governing permissions and</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * limitations under the License.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;stdarg.h&gt;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;sys/socket.h&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;errno.h&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="libsoundmanager_8hpp.html">libsoundmanager.hpp</a>&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">   25</a></span>&#160;<span class="preprocessor">#define ELOG(args,...) _ELOG(__FUNCTION__,__LINE__,args,##__VA_ARGS__)</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifdef DEBUGMODE</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor"> #define DLOG(args,...) _DLOG(__FUNCTION__,__LINE__,args,##__VA_ARGS__)</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="libsoundmanager_8cpp.html#a4e42b2f5af2174dd24f958351becf63d">   29</a></span>&#160;<span class="preprocessor"> #define DLOG(args,...)</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> _DLOG(<span class="keyword">const</span> <span class="keywordtype">char</span>* func, <span class="keyword">const</span> <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span>* log, ...);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> _ELOG(<span class="keyword">const</span> <span class="keywordtype">char</span>* func, <span class="keyword">const</span> <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span>* log, ...);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">using namespace </span><a class="code" href="namespacestd.html">std</a>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">static</span> <span class="keywordtype">bool</span> has_verb(<span class="keyword">const</span> std::string&amp; verb);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> API[] = <span class="stringliteral">&quot;soundmanager&quot;</span>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">static</span> <span class="keywordtype">int</span> eventIndent(<span class="keyword">const</span> <span class="keywordtype">string</span>&amp; <a class="code" href="structevent.html">event</a>);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">static</span> <span class="keyword">const</span> std::vector&lt;std::string&gt; api_list{</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    std::string(<span class="stringliteral">&quot;connect&quot;</span>),</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    std::string(<span class="stringliteral">&quot;disconnect&quot;</span>),</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    std::string(<span class="stringliteral">&quot;setVolume&quot;</span>),</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    std::string(<span class="stringliteral">&quot;volumeStep&quot;</span>),</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    std::string(<span class="stringliteral">&quot;setSinkMuteState&quot;</span>),</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    std::string(<span class="stringliteral">&quot;getListMainConnections&quot;</span>),</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    std::string(<span class="stringliteral">&quot;ackConnect&quot;</span>),</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    std::string(<span class="stringliteral">&quot;ackDisconnect&quot;</span>),</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    std::string(<span class="stringliteral">&quot;ackSetSourceState&quot;</span>),    </div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    std::string(<span class="stringliteral">&quot;registerSource&quot;</span>),</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    std::string(<span class="stringliteral">&quot;deregisterSource&quot;</span>),</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    std::string(<span class="stringliteral">&quot;subscribe&quot;</span>),</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    std::string(<span class="stringliteral">&quot;unsubscribe&quot;</span>)</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;};</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">static</span> <span class="keyword">const</span> std::vector&lt;std::string&gt; event_list{</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    std::string(<span class="stringliteral">&quot;asyncSetSourceState&quot;</span>),</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    std::string(<span class="stringliteral">&quot;newMainConnection&quot;</span>),</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    std::string(<span class="stringliteral">&quot;volumeChanged&quot;</span>),</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    std::string(<span class="stringliteral">&quot;removedMainConnection&quot;</span>),</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    std::string(<span class="stringliteral">&quot;sinkMuteStateChanged&quot;</span>),</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    std::string(<span class="stringliteral">&quot;mainConnectionStateChanged&quot;</span>),</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    std::string(<span class="stringliteral">&quot;setRoutingReady&quot;</span>),</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    std::string(<span class="stringliteral">&quot;setRoutingRundown&quot;</span>),</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    std::string(<span class="stringliteral">&quot;asyncConnect&quot;</span>)</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;};</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> _on_hangup_static(<span class="keywordtype">void</span> *closure, <span class="keyword">struct</span> afb_wsj1 *wsj)</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;{</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">static_cast&lt;</span><a class="code" href="class_lib_soundmanager.html">LibSoundmanager</a>*<span class="keyword">&gt;</span>(closure)-&gt;on_hangup(NULL,wsj);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;}</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> _on_call_static(<span class="keywordtype">void</span> *closure, <span class="keyword">const</span> <span class="keywordtype">char</span> *api, <span class="keyword">const</span> <span class="keywordtype">char</span> *verb, <span class="keyword">struct</span> afb_wsj1_msg *msg)</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;{</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="comment">/* LibSoundmanager is not called from other process */</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;}</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> _on_event_static(<span class="keywordtype">void</span>* closure, <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structevent.html">event</a>, <span class="keyword">struct</span> afb_wsj1_msg *msg)</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;{</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keyword">static_cast&lt;</span><a class="code" href="class_lib_soundmanager.html">LibSoundmanager</a>*<span class="keyword">&gt;</span>(closure)-&gt;on_event(NULL,event,msg);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;}</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> _on_reply_static(<span class="keywordtype">void</span> *closure, <span class="keyword">struct</span> afb_wsj1_msg *msg)</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;{</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keyword">static_cast&lt;</span><a class="code" href="class_lib_soundmanager.html">LibSoundmanager</a>*<span class="keyword">&gt;</span>(closure)-&gt;on_reply(NULL,msg);     </div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;}</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> *event_loop_run(<span class="keywordtype">void</span> *args)</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;{</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keyword">struct </span>sd_event* loop = (<span class="keyword">struct </span>sd_event*)(args);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="libsoundmanager_8cpp.html#a4e42b2f5af2174dd24f958351becf63d">DLOG</a>(<span class="stringliteral">&quot;start eventloop&quot;</span>);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">for</span>(;;)</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        sd_event_run(loop, 30000000);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;}</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a8b51e9891813cb62dd12109c017ad106">   96</a></span>&#160;<a class="code" href="class_lib_soundmanager.html#a8b51e9891813cb62dd12109c017ad106">LibSoundmanager::LibSoundmanager</a>()</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;{</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;}</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#abf861908e3d6d85d2b3c08683b08f934">  100</a></span>&#160;<a class="code" href="class_lib_soundmanager.html#abf861908e3d6d85d2b3c08683b08f934">LibSoundmanager::~LibSoundmanager</a>()</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;{</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">if</span>(mploop)</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    {</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        sd_event_unref(mploop);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    }</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordflow">if</span>(sp_websock != NULL)</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    {</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        afb_wsj1_unref(sp_websock);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    }</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;}</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#ad5026736048e49c640b25f790409a65e">  126</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#ad5026736048e49c640b25f790409a65e">LibSoundmanager::init</a>(<span class="keywordtype">int</span> port, <span class="keyword">const</span> <span class="keywordtype">string</span>&amp; token)</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;{</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keywordtype">int</span> ret;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">if</span>(port &gt; 0 &amp;&amp; token.size() &gt; 0)</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    {</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        mport = port;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        mtoken = token;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    }</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    {</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;port and token should be &gt; 0, Initial port and token uses.&quot;</span>);</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    }</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    ret = initialize_websocket();</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="keywordflow">if</span>(ret != 0 )</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    {</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to initialize websocket&quot;</span>);</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    }</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    ret = init_event();</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="keywordflow">if</span>(ret != 0 )</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    {</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to initialize websocket&quot;</span>);</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    }</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordflow">if</span>(ret == -1){</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to create thread&quot;</span>);</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    }</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;}</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="keywordtype">int</span> LibSoundmanager::initialize_websocket()</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;{</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    mploop = NULL;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    onEvent = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    onReply = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <span class="keywordtype">int</span> ret = sd_event_default(&amp;mploop);</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    <span class="keywordflow">if</span>(ret &lt; 0)</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    {</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to create event loop&quot;</span>);</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="keywordflow">goto</span> END;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    }</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <span class="comment">/* Initialize interface from websocket */</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    minterface.on_hangup = _on_hangup_static;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    minterface.on_call = _on_call_static;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    minterface.on_event = _on_event_static;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <span class="keywordtype">string</span> muri = <span class="stringliteral">&quot;ws://localhost:&quot;</span> + to_string(mport) + <span class="stringliteral">&quot;/api?token=&quot;</span> + mtoken;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    sp_websock = afb_ws_client_connect_wsj1(mploop, muri.c_str(), &amp;minterface, <span class="keyword">this</span>);</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    }</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="keywordflow">if</span>(sp_websock == NULL)</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    {</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to create websocket connection&quot;</span>);</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keywordflow">goto</span> END;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    }</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;END:</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="keywordflow">if</span>(mploop)</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    {</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        sd_event_unref(mploop);</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    }</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;}</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="keywordtype">int</span> LibSoundmanager::init_event(){</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    <span class="comment">/* subscribe most important event for sound right */</span></div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordflow">return</span> subscribe(<span class="keywordtype">string</span>(<span class="stringliteral">&quot;asyncSetSourceState&quot;</span>));</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;}</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_lib_soundmanager.html#a472149619f68c2387d4ff7e02845db26">LibSoundmanager::register_callback</a>(</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    <span class="keywordtype">void</span> (*event_cb)(<span class="keyword">const</span> <span class="keywordtype">string</span>&amp; event, <span class="keyword">struct</span> json_object* event_contents), </div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keywordtype">void</span> (*reply_cb)(<span class="keyword">struct</span> json_object* reply_contents),</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <span class="keywordtype">void</span> (*hangup_cb)(<span class="keywordtype">void</span>))</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;{</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    onEvent = event_cb;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    onReply = reply_cb;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    onHangup = hangup_cb;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;}</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00236"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#ab7fd9ce3fae6ab6e0806ff099ad681f0">  236</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_lib_soundmanager.html#a472149619f68c2387d4ff7e02845db26">LibSoundmanager::register_callback</a>(</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <span class="keywordtype">void</span> (*reply_cb)(<span class="keyword">struct</span> json_object* reply_contents),</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    <span class="keywordtype">void</span> (*hangup_cb)(<span class="keywordtype">void</span>))</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;{</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    onReply = reply_cb;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    onHangup = hangup_cb;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;}</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a5353df3686a64c74c9672efd0c156351">  259</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#a5353df3686a64c74c9672efd0c156351">LibSoundmanager::registerSource</a>(<span class="keyword">const</span> <span class="keywordtype">string</span>&amp; sourceName)</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;{</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    {</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    }</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="keyword">struct </span>json_object* j_obj = json_object_new_object();</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="keyword">struct </span>json_object* jsn = json_object_new_string(sourceName.c_str());</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;appname&quot;</span>, jsn);</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    <span class="keywordflow">return</span> this-&gt;call(__FUNCTION__, j_obj);</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;}</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div><div class="line"><a name="l00287"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#aa570a8373e057127c85107e13053669c">  287</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#aa570a8373e057127c85107e13053669c">LibSoundmanager::connect</a>(<span class="keywordtype">int</span> sourceID, <span class="keywordtype">int</span> sinkID)</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;{</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    {</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    }</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="keyword">struct </span>json_object* j_obj = json_object_new_object();</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    <span class="keyword">struct </span>json_object* jsource = json_object_new_int(sourceID);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="keyword">struct </span>json_object* jsink = json_object_new_int(sinkID);</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;sourceID&quot;</span>, jsource);</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;sinkID&quot;</span>, jsink);</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <span class="keywordflow">return</span> this-&gt;call(__FUNCTION__, j_obj);</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;}</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#aa570a8373e057127c85107e13053669c">LibSoundmanager::connect</a>(<span class="keywordtype">int</span> sourceID, <span class="keyword">const</span> <span class="keywordtype">string</span>&amp; sinkName)</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;{</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    {</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    }</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    <span class="keyword">struct </span>json_object* j_obj = json_object_new_object();</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    <span class="keyword">struct </span>json_object* jsource = json_object_new_int(sourceID);</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    <span class="comment">//struct json_object* jsink = json_object_new_int(1);</span></div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    <span class="keyword">struct </span>json_object* jsink = json_object_new_string(sinkName.c_str());</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;sourceID&quot;</span>, jsource);</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;sinkID&quot;</span>, jsink);</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    <span class="keywordflow">return</span> this-&gt;call(__FUNCTION__, j_obj);</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;}</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;</div><div class="line"><a name="l00347"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a3e59dfb464c81824d32f3391dea9b295">  347</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#a3e59dfb464c81824d32f3391dea9b295">LibSoundmanager::disconnect</a>(<span class="keywordtype">int</span> connectionID)</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;{</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    {</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    }</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    <span class="keyword">struct </span>json_object* j_obj = json_object_new_object();</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    <span class="keyword">struct </span>json_object* jconnection = json_object_new_int(connectionID);</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;mainConnectionID&quot;</span>, jconnection);</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    <span class="keywordflow">return</span> this-&gt;call(__FUNCTION__, j_obj);</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;}</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div><div class="line"><a name="l00374"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a66e6fd5ef9955df2295c450400d6eb74">  374</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#a66e6fd5ef9955df2295c450400d6eb74">LibSoundmanager::ackSetSourceState</a>(<span class="keywordtype">int</span> handle, <span class="keywordtype">int</span> error)</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;{</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    {</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    }</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <span class="keyword">struct </span>json_object* j_obj = json_object_new_object();</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    <span class="keyword">struct </span>json_object* jhandle = json_object_new_int(handle);</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    <span class="keyword">struct </span>json_object* jerrno = json_object_new_int(error);</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;handle&quot;</span>, jhandle);</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;error&quot;</span>, jerrno);</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;    <span class="keywordflow">return</span> this-&gt;call(__FUNCTION__, j_obj);</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;}</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#a1fe952a4dabbab6126cc23e36c79c773">LibSoundmanager::call</a>(<span class="keyword">const</span> <span class="keywordtype">string</span>&amp; verb, <span class="keyword">struct</span> json_object* arg)</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;{</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;    <span class="keywordtype">int</span> ret;</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    {</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;    }</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;    <span class="keywordflow">if</span> (!has_verb(verb))</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;    {</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;verb doesn&#39;t exit&quot;</span>);</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    }</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    ret = afb_wsj1_call_j(sp_websock, API, verb.c_str(), arg, _on_reply_static, <span class="keyword">this</span>);</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    <span class="keywordflow">if</span> (ret &lt; 0) {</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to call verb:%s&quot;</span>,verb.c_str());</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;    }</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;    <span class="keywordflow">return</span> ret;</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;}</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;</div><div class="line"><a name="l00436"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a872d65bc665189c7b6a882c6067daaed">  436</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#a1fe952a4dabbab6126cc23e36c79c773">LibSoundmanager::call</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* verb, <span class="keyword">struct</span> json_object* arg)</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;{</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;    <span class="keywordtype">int</span> ret;</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;    {</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;    }</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;    <span class="keywordflow">if</span> (!has_verb(<span class="keywordtype">string</span>(verb)))</div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;    {</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;verb doesn&#39;t exit&quot;</span>);</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    }</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;    ret = afb_wsj1_call_j(sp_websock, API, verb, arg, _on_reply_static, <span class="keyword">this</span>);</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;    <span class="keywordflow">if</span> (ret &lt; 0) {</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to call verb:%s&quot;</span>,verb);</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;    }</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;    <span class="keywordflow">return</span> ret;</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;}</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;</div><div class="line"><a name="l00469"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a9cd7c5470cb135f9b1aa56d790c7e91e">  469</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#a9cd7c5470cb135f9b1aa56d790c7e91e">LibSoundmanager::subscribe</a>(<span class="keyword">const</span> <span class="keywordtype">string</span>&amp; event_name)</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;{</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;    {</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;    }</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;    <span class="keyword">struct </span>json_object* j_obj = json_object_new_object();</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;event&quot;</span>, json_object_new_string(event_name.c_str()));</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;    <span class="keywordtype">int</span> ret = afb_wsj1_call_j(sp_websock, API, <span class="stringliteral">&quot;subscribe&quot;</span>, j_obj, _on_reply_static, <span class="keyword">this</span>);</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;    <span class="keywordflow">if</span> (ret &lt; 0) {</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to call verb:%s&quot;</span>,__FUNCTION__);</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;    }</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;    <span class="keywordflow">return</span> ret;</div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;}</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;</div><div class="line"><a name="l00498"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a21060844aa7efad6473b6104546afb06">  498</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="class_lib_soundmanager.html#a21060844aa7efad6473b6104546afb06">LibSoundmanager::unsubscribe</a>(<span class="keyword">const</span> <span class="keywordtype">string</span>&amp; event_name)</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;{</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;    <span class="keywordflow">if</span>(!sp_websock)</div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;    {</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;    }</div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;    <span class="keyword">struct </span>json_object* j_obj = json_object_new_object();</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;    json_object_object_add(j_obj, <span class="stringliteral">&quot;event&quot;</span>, json_object_new_string(event_name.c_str()));</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;    <span class="keywordtype">int</span> ret = afb_wsj1_call_j(sp_websock, API, <span class="stringliteral">&quot;unsubscribe&quot;</span>, j_obj, _on_reply_static, <span class="keyword">this</span>);</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;    <span class="keywordflow">if</span> (ret &lt; 0) {</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;        <a class="code" href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a>(<span class="stringliteral">&quot;Failed to call verb:%s&quot;</span>,__FUNCTION__);</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;    }</div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;    <span class="keywordflow">return</span> ret;</div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;}</div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;</div><div class="line"><a name="l00528"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#af39e2ddfb07ec049565b61ab4e1fbf8d">  528</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_lib_soundmanager.html#af39e2ddfb07ec049565b61ab4e1fbf8d">LibSoundmanager::set_event_handler</a>(<span class="keyword">enum</span> <a class="code" href="class_lib_soundmanager.html#abd76525512641c001c3187629b58db07">EventType_SM</a> et, <a class="code" href="class_lib_soundmanager.html#a7c28533bfc9315d8d0b417653611aba7">handler_fun</a> f)</div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;{</div><div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;    <span class="keywordflow">if</span> (et &gt; 1 &amp;&amp; et &lt; NumItems) {</div><div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;        this-&gt;handlers[et] = std::move(f);</div><div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;    }</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;}</div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;</div><div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;</div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;<span class="comment">/************* Callback Function *************/</span></div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;</div><div class="line"><a name="l00538"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a71a8165cb15c7815aa95a8955f5cd7f6">  538</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_lib_soundmanager.html#a71a8165cb15c7815aa95a8955f5cd7f6">LibSoundmanager::on_hangup</a>(<span class="keywordtype">void</span> *closure, <span class="keyword">struct</span> afb_wsj1 *wsj)</div><div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;{</div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;    <a class="code" href="libsoundmanager_8cpp.html#a4e42b2f5af2174dd24f958351becf63d">DLOG</a>(<span class="stringliteral">&quot;%s called&quot;</span>, __FUNCTION__);</div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;    <span class="keywordflow">if</span>(onHangup != <span class="keyword">nullptr</span>)</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;    {</div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;        onHangup();</div><div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;    }</div><div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;}</div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;</div><div class="line"><a name="l00547"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a3ba2255cb1d29c77c4c6a2267949eda0">  547</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_lib_soundmanager.html#a3ba2255cb1d29c77c4c6a2267949eda0">LibSoundmanager::on_call</a>(<span class="keywordtype">void</span> *closure, <span class="keyword">const</span> <span class="keywordtype">char</span> *api, <span class="keyword">const</span> <span class="keywordtype">char</span> *verb, <span class="keyword">struct</span> afb_wsj1_msg *msg)</div><div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160;{</div><div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;}</div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;<span class="comment">* event is like &quot;soundmanager/newMainConnection&quot;</span></div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;<span class="comment">* msg is like {&quot;event&quot;:&quot;soundmanager\/newMainConnection&quot;,&quot;data&quot;:{&quot;mainConnectionID&quot;:3,&quot;sourceID&quot;:101,&quot;sinkID&quot;:100,&quot;delay&quot;:0,&quot;connectionState&quot;:4},&quot;jtype&quot;:&quot;afb-event&quot;})}</span></div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;<span class="comment">*               ^key^   ^^^^^^^^^^^^ value ^^^^^^^^^^^^</span></div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;<span class="comment">* so you can get </span></div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;<span class="comment">    event name : struct json_object obj = json_object_object_get(msg,&quot;event&quot;)</span></div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;<span class="comment">*/</span> </div><div class="line"><a name="l00558"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a86ef62e7847cd20e9cafbc1f6c017b3e">  558</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_lib_soundmanager.html#a86ef62e7847cd20e9cafbc1f6c017b3e">LibSoundmanager::on_event</a>(<span class="keywordtype">void</span> *closure, <span class="keyword">const</span> <span class="keywordtype">char</span> *event, <span class="keyword">struct</span> afb_wsj1_msg *msg)</div><div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160;{</div><div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;    <span class="comment">/* check event is for us */</span></div><div class="line"><a name="l00561"></a><span class="lineno">  561</span>&#160;    <span class="keywordtype">string</span> ev = string(event);</div><div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160;    <span class="keywordflow">if</span> (ev.find(API) == string::npos) {</div><div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;        <span class="comment">/* It&#39;s not us */</span></div><div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00565"></a><span class="lineno">  565</span>&#160;    }</div><div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160;    <span class="keyword">struct </span>json_object* ev_contents = afb_wsj1_msg_object_j(msg);</div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;    <span class="keywordflow">if</span>(onEvent != <span class="keyword">nullptr</span>)</div><div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;    {</div><div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;        onEvent(ev, ev_contents);</div><div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;    }</div><div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;    <span class="keywordflow">else</span>{}</div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;</div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;    dispatch_event(ev, ev_contents);</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;    </div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;    json_object_put(ev_contents);</div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;}</div><div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;</div><div class="line"><a name="l00578"></a><span class="lineno"><a class="line" href="class_lib_soundmanager.html#a69b4f10e509605a570cc52c795bc9d51">  578</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_lib_soundmanager.html#a69b4f10e509605a570cc52c795bc9d51">LibSoundmanager::on_reply</a>(<span class="keywordtype">void</span> *closure, <span class="keyword">struct</span> afb_wsj1_msg *msg)</div><div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;{</div><div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;    <span class="keyword">struct </span>json_object* reply = afb_wsj1_msg_object_j(msg);</div><div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;    <span class="comment">/*struct json_object *json_data = json_object_object_get(reply, &quot;response&quot;);</span></div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;<span class="comment">    struct json_object *jverb = json_object_object_get(json_data, &quot;verb&quot;);</span></div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;<span class="comment">    const char* cverb = json_object_get_string(jverb);</span></div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;<span class="comment">    DLOG(&quot;cverb is %s&quot;,cverb);</span></div><div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;<span class="comment">    string verb = string(cverb);</span></div><div class="line"><a name="l00586"></a><span class="lineno">  586</span>&#160;<span class="comment">    DLOG(&quot;verb is %s&quot;,verb.c_str());</span></div><div class="line"><a name="l00587"></a><span class="lineno">  587</span>&#160;<span class="comment">    </span></div><div class="line"><a name="l00588"></a><span class="lineno">  588</span>&#160;<span class="comment">    if(verb == &quot;registerSource&quot;){</span></div><div class="line"><a name="l00589"></a><span class="lineno">  589</span>&#160;<span class="comment">        struct json_object *jsourceID = json_object_object_get(json_data, &quot;sourceID&quot;);</span></div><div class="line"><a name="l00590"></a><span class="lineno">  590</span>&#160;<span class="comment">        int sourceID = json_object_get_int(jsourceID);</span></div><div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;<span class="comment">        msourceIDs.push_back(sourceID);</span></div><div class="line"><a name="l00592"></a><span class="lineno">  592</span>&#160;<span class="comment">        DLOG(&quot;my sourceID is created: %d&quot;, sourceID);</span></div><div class="line"><a name="l00593"></a><span class="lineno">  593</span>&#160;<span class="comment">    }*/</span></div><div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160;    <span class="keywordflow">if</span>(onReply != <span class="keyword">nullptr</span>)</div><div class="line"><a name="l00595"></a><span class="lineno">  595</span>&#160;    {</div><div class="line"><a name="l00596"></a><span class="lineno">  596</span>&#160;        onReply(reply);</div><div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;    }</div><div class="line"><a name="l00598"></a><span class="lineno">  598</span>&#160;    json_object_put(reply); </div><div class="line"><a name="l00599"></a><span class="lineno">  599</span>&#160;}</div><div class="line"><a name="l00600"></a><span class="lineno">  600</span>&#160;</div><div class="line"><a name="l00601"></a><span class="lineno">  601</span>&#160;<span class="keywordtype">int</span> LibSoundmanager::dispatch_event(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;event , json_object* event_contents){</div><div class="line"><a name="l00602"></a><span class="lineno">  602</span>&#160;    <span class="comment">//dipatch event</span></div><div class="line"><a name="l00603"></a><span class="lineno">  603</span>&#160;    <a class="code" href="class_lib_soundmanager.html#abd76525512641c001c3187629b58db07">EventType_SM</a> x;</div><div class="line"><a name="l00604"></a><span class="lineno">  604</span>&#160;</div><div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160;    <span class="keywordflow">if</span>(event.find(event_list[0].c_str())){</div><div class="line"><a name="l00606"></a><span class="lineno">  606</span>&#160;        x = Event_AsyncSetSourceState;</div><div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;    }</div><div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;    <span class="keywordflow">else</span>{</div><div class="line"><a name="l00609"></a><span class="lineno">  609</span>&#160;        <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00610"></a><span class="lineno">  610</span>&#160;    }</div><div class="line"><a name="l00611"></a><span class="lineno">  611</span>&#160;    <span class="keyword">auto</span> i = this-&gt;handlers.find(x);</div><div class="line"><a name="l00612"></a><span class="lineno">  612</span>&#160;    <span class="keywordflow">if</span>(i != handlers.end()){</div><div class="line"><a name="l00613"></a><span class="lineno">  613</span>&#160;        i-&gt;second(event_contents);</div><div class="line"><a name="l00614"></a><span class="lineno">  614</span>&#160;        <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00615"></a><span class="lineno">  615</span>&#160;    }</div><div class="line"><a name="l00616"></a><span class="lineno">  616</span>&#160;    <span class="keywordflow">return</span> -1;</div><div class="line"><a name="l00617"></a><span class="lineno">  617</span>&#160;}</div><div class="line"><a name="l00618"></a><span class="lineno">  618</span>&#160;</div><div class="line"><a name="l00619"></a><span class="lineno">  619</span>&#160;<span class="comment">/* Internal Function in libsoundmanager */</span></div><div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;</div><div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> _ELOG(<span class="keyword">const</span> <span class="keywordtype">char</span>* func, <span class="keyword">const</span> <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span>* log, ...)</div><div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160;{</div><div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;    <span class="keywordtype">char</span> *message;</div><div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160;    va_list args;</div><div class="line"><a name="l00625"></a><span class="lineno">  625</span>&#160;    va_start(args, log);</div><div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;    <span class="keywordflow">if</span> (log == NULL || vasprintf(&amp;message, log, args) &lt; 0)</div><div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;        message = NULL;</div><div class="line"><a name="l00628"></a><span class="lineno">  628</span>&#160;    cout &lt;&lt; <span class="stringliteral">&quot;[ERROR: soundmanager]&quot;</span> &lt;&lt; func &lt;&lt; <span class="stringliteral">&quot;(&quot;</span> &lt;&lt; line &lt;&lt; <span class="stringliteral">&quot;):&quot;</span> &lt;&lt; message &lt;&lt; endl; </div><div class="line"><a name="l00629"></a><span class="lineno">  629</span>&#160;    va_end(args);</div><div class="line"><a name="l00630"></a><span class="lineno">  630</span>&#160;    free(message);</div><div class="line"><a name="l00631"></a><span class="lineno">  631</span>&#160;}</div><div class="line"><a name="l00632"></a><span class="lineno">  632</span>&#160;</div><div class="line"><a name="l00633"></a><span class="lineno">  633</span>&#160;<span class="keyword">static</span> <span class="keywordtype">void</span> _DLOG(<span class="keyword">const</span> <span class="keywordtype">char</span>* func, <span class="keyword">const</span> <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span>* log, ...)</div><div class="line"><a name="l00634"></a><span class="lineno">  634</span>&#160;{</div><div class="line"><a name="l00635"></a><span class="lineno">  635</span>&#160;    <span class="keywordtype">char</span> *message;</div><div class="line"><a name="l00636"></a><span class="lineno">  636</span>&#160;    va_list args;</div><div class="line"><a name="l00637"></a><span class="lineno">  637</span>&#160;    va_start(args, log);</div><div class="line"><a name="l00638"></a><span class="lineno">  638</span>&#160;    <span class="keywordflow">if</span> (log == NULL || vasprintf(&amp;message, log, args) &lt; 0)</div><div class="line"><a name="l00639"></a><span class="lineno">  639</span>&#160;        message = NULL;</div><div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160;    cout &lt;&lt; <span class="stringliteral">&quot;[DEBUG: soundmanager]&quot;</span> &lt;&lt; func &lt;&lt; <span class="stringliteral">&quot;(&quot;</span> &lt;&lt; line &lt;&lt; <span class="stringliteral">&quot;):&quot;</span> &lt;&lt; message &lt;&lt; endl; </div><div class="line"><a name="l00641"></a><span class="lineno">  641</span>&#160;    va_end(args);</div><div class="line"><a name="l00642"></a><span class="lineno">  642</span>&#160;    free(message);</div><div class="line"><a name="l00643"></a><span class="lineno">  643</span>&#160;}</div><div class="line"><a name="l00644"></a><span class="lineno">  644</span>&#160;</div><div class="line"><a name="l00645"></a><span class="lineno">  645</span>&#160;<span class="keyword">static</span> <span class="keywordtype">bool</span> has_verb(<span class="keyword">const</span> <span class="keywordtype">string</span>&amp; verb)</div><div class="line"><a name="l00646"></a><span class="lineno">  646</span>&#160;{</div><div class="line"><a name="l00647"></a><span class="lineno">  647</span>&#160;    <span class="keywordflow">if</span>(find(api_list.begin(), api_list.end(), verb) != api_list.end())</div><div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00649"></a><span class="lineno">  649</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00651"></a><span class="lineno">  651</span>&#160;}</div><div class="ttc" id="class_lib_soundmanager_html_abd76525512641c001c3187629b58db07"><div class="ttname"><a href="class_lib_soundmanager.html#abd76525512641c001c3187629b58db07">LibSoundmanager::EventType_SM</a></div><div class="ttdeci">EventType_SM</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8hpp_source.html#l00043">libsoundmanager.hpp:43</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a472149619f68c2387d4ff7e02845db26"><div class="ttname"><a href="class_lib_soundmanager.html#a472149619f68c2387d4ff7e02845db26">LibSoundmanager::register_callback</a></div><div class="ttdeci">void register_callback(void(*event_cb)(const std::string &amp;event, struct json_object *event_contents), void(*reply_cb)(struct json_object *reply_contents), void(*hangup_cb)(void)=nullptr)</div></div>
<div class="ttc" id="class_lib_soundmanager_html_af39e2ddfb07ec049565b61ab4e1fbf8d"><div class="ttname"><a href="class_lib_soundmanager.html#af39e2ddfb07ec049565b61ab4e1fbf8d">LibSoundmanager::set_event_handler</a></div><div class="ttdeci">void set_event_handler(enum EventType_SM et, handler_fun f)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00528">libsoundmanager.cpp:528</a></div></div>
<div class="ttc" id="structevent_html"><div class="ttname"><a href="structevent.html">event</a></div><div class="ttdef"><b>Definition:</b> <a href="soundmanager_8c_source.html#l00066">soundmanager.c:66</a></div></div>
<div class="ttc" id="namespacestd_html"><div class="ttname"><a href="namespacestd.html">std</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_ad5026736048e49c640b25f790409a65e"><div class="ttname"><a href="class_lib_soundmanager.html#ad5026736048e49c640b25f790409a65e">LibSoundmanager::init</a></div><div class="ttdeci">int init(int port, const std::string &amp;token)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00126">libsoundmanager.cpp:126</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a21060844aa7efad6473b6104546afb06"><div class="ttname"><a href="class_lib_soundmanager.html#a21060844aa7efad6473b6104546afb06">LibSoundmanager::unsubscribe</a></div><div class="ttdeci">int unsubscribe(const std::string &amp;event_name)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00498">libsoundmanager.cpp:498</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a3e59dfb464c81824d32f3391dea9b295"><div class="ttname"><a href="class_lib_soundmanager.html#a3e59dfb464c81824d32f3391dea9b295">LibSoundmanager::disconnect</a></div><div class="ttdeci">int disconnect(int connectionID)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00347">libsoundmanager.cpp:347</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a1fe952a4dabbab6126cc23e36c79c773"><div class="ttname"><a href="class_lib_soundmanager.html#a1fe952a4dabbab6126cc23e36c79c773">LibSoundmanager::call</a></div><div class="ttdeci">int call(const std::string &amp;verb, struct json_object *arg)</div></div>
<div class="ttc" id="class_lib_soundmanager_html_aa570a8373e057127c85107e13053669c"><div class="ttname"><a href="class_lib_soundmanager.html#aa570a8373e057127c85107e13053669c">LibSoundmanager::connect</a></div><div class="ttdeci">int connect(int sourceID, int sinkID)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00287">libsoundmanager.cpp:287</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a7c28533bfc9315d8d0b417653611aba7"><div class="ttname"><a href="class_lib_soundmanager.html#a7c28533bfc9315d8d0b417653611aba7">LibSoundmanager::handler_fun</a></div><div class="ttdeci">std::function&lt; void(struct json_object *)&gt; handler_fun</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8hpp_source.html#l00041">libsoundmanager.hpp:41</a></div></div>
<div class="ttc" id="libsoundmanager_8hpp_html"><div class="ttname"><a href="libsoundmanager_8hpp.html">libsoundmanager.hpp</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a8b51e9891813cb62dd12109c017ad106"><div class="ttname"><a href="class_lib_soundmanager.html#a8b51e9891813cb62dd12109c017ad106">LibSoundmanager::LibSoundmanager</a></div><div class="ttdeci">LibSoundmanager()</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00096">libsoundmanager.cpp:96</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_abf861908e3d6d85d2b3c08683b08f934"><div class="ttname"><a href="class_lib_soundmanager.html#abf861908e3d6d85d2b3c08683b08f934">LibSoundmanager::~LibSoundmanager</a></div><div class="ttdeci">~LibSoundmanager()</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00100">libsoundmanager.cpp:100</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a71a8165cb15c7815aa95a8955f5cd7f6"><div class="ttname"><a href="class_lib_soundmanager.html#a71a8165cb15c7815aa95a8955f5cd7f6">LibSoundmanager::on_hangup</a></div><div class="ttdeci">void on_hangup(void *closure, struct afb_wsj1 *wsj)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00538">libsoundmanager.cpp:538</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a9cd7c5470cb135f9b1aa56d790c7e91e"><div class="ttname"><a href="class_lib_soundmanager.html#a9cd7c5470cb135f9b1aa56d790c7e91e">LibSoundmanager::subscribe</a></div><div class="ttdeci">int subscribe(const std::string &amp;event_name)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00469">libsoundmanager.cpp:469</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a66e6fd5ef9955df2295c450400d6eb74"><div class="ttname"><a href="class_lib_soundmanager.html#a66e6fd5ef9955df2295c450400d6eb74">LibSoundmanager::ackSetSourceState</a></div><div class="ttdeci">int ackSetSourceState(int handle, int error)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00374">libsoundmanager.cpp:374</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a69b4f10e509605a570cc52c795bc9d51"><div class="ttname"><a href="class_lib_soundmanager.html#a69b4f10e509605a570cc52c795bc9d51">LibSoundmanager::on_reply</a></div><div class="ttdeci">void on_reply(void *closure, struct afb_wsj1_msg *msg)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00578">libsoundmanager.cpp:578</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html"><div class="ttname"><a href="class_lib_soundmanager.html">LibSoundmanager</a></div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8hpp_source.html#l00032">libsoundmanager.hpp:32</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a3ba2255cb1d29c77c4c6a2267949eda0"><div class="ttname"><a href="class_lib_soundmanager.html#a3ba2255cb1d29c77c4c6a2267949eda0">LibSoundmanager::on_call</a></div><div class="ttdeci">void on_call(void *closure, const char *api, const char *verb, struct afb_wsj1_msg *msg)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00547">libsoundmanager.cpp:547</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a86ef62e7847cd20e9cafbc1f6c017b3e"><div class="ttname"><a href="class_lib_soundmanager.html#a86ef62e7847cd20e9cafbc1f6c017b3e">LibSoundmanager::on_event</a></div><div class="ttdeci">void on_event(void *closure, const char *event, struct afb_wsj1_msg *msg)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00558">libsoundmanager.cpp:558</a></div></div>
<div class="ttc" id="class_lib_soundmanager_html_a5353df3686a64c74c9672efd0c156351"><div class="ttname"><a href="class_lib_soundmanager.html#a5353df3686a64c74c9672efd0c156351">LibSoundmanager::registerSource</a></div><div class="ttdeci">int registerSource(const std::string &amp;sourceName)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00259">libsoundmanager.cpp:259</a></div></div>
<div class="ttc" id="libsoundmanager_8cpp_html_a797aa3053bd6a29819d44f8fad8a5eca"><div class="ttname"><a href="libsoundmanager_8cpp.html#a797aa3053bd6a29819d44f8fad8a5eca">ELOG</a></div><div class="ttdeci">#define ELOG(args,...)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00025">libsoundmanager.cpp:25</a></div></div>
<div class="ttc" id="libsoundmanager_8cpp_html_a4e42b2f5af2174dd24f958351becf63d"><div class="ttname"><a href="libsoundmanager_8cpp.html#a4e42b2f5af2174dd24f958351becf63d">DLOG</a></div><div class="ttdeci">#define DLOG(args,...)</div><div class="ttdef"><b>Definition:</b> <a href="libsoundmanager_8cpp_source.html#l00029">libsoundmanager.cpp:29</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_fc265b39262ea2713c037617d421974d.html">R:</a></li><li class="navelem"><a class="el" href="dir_c0f9ac54811231ea41ecdb457a109fa8.html">SoundManagerBinding</a></li><li class="navelem"><a class="el" href="dir_b62d30696523dc2fcd1e0f670058b8e1.html">libsoundmanager</a></li><li class="navelem"><a class="el" href="libsoundmanager_8cpp.html">libsoundmanager.cpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
